import { Form } from '../../e2elib/lib/src/pageobjects/form.component';
import { ListSOP } from '../../libappsop/listsop';
import { DialogDummy } from '../dialogs/dialog.dummy';
import { DialogRecipe } from '../dialogs/dialog.recipe';

export class FormRecipeDefinition extends Form {
  public listRecipe = new ListRecipe();
  public listRecipeIngredient = new ListRecipeIngredient();

  public constructor() {
    super('FormRecipeDefinitions');
  }
}

export class ListRecipe extends ListSOP<DialogRecipe, ListRecipeColumn> {
  public constructor() {
    super('ListRecipe', new DialogRecipe());

    // Set primary key column name(s), to display in error message when assert fails
    this.rowPrimaryColumnNames = {Name: ''};
    this.rowAllConstraintsColumnName = {'All constraints': ''};
  }
}

// Use DialogDummy as not yet automate tests that require the dialog, replace with actual implementation if start automation tests that requires it
export class ListRecipeIngredient extends ListSOP<DialogDummy, ListRecipeIngredientColumn> {
  public constructor() {
    super('ListRecipeIngredient', new DialogDummy());

    // Set primary key column name(s), to display in error message when assert fails
    this.rowPrimaryColumnNames = {'Display name': ''};
  }
}

export interface ListRecipeColumn {
  'All constraints'?: string;
  Name?: string;
  Description?: string;
}

const listRecipeContextMenuItem = {
  Create: { ContextMenu: 'listContextMenuRecipe', Name: 'MenuCreate', Label: 'Create' },
  CreateRecipeIngredient: { ContextMenu: 'listContextMenuRecipe', Name: 'MenuCreateRecipeIngredient', Label: 'Create recipe ingredients' },
  Edit: { ContextMenu: 'listContextMenuRecipe', Name: 'MenuEdit', Label: 'Edit' },
};

export { listRecipeContextMenuItem as ListRecipeContextMenuItem };

export interface ListRecipeIngredientColumn {
  'Display name'?: string;
  Minimum?: string;
  Maximum?: string;
  Nominal?: string;
}
